#
# This is the make file for the mvar_lib library.
#
#                               Gershon Elber, May 1997
#

include ../makeflag.sas

OBJS =  crv_krnl.o ms2circ.o mvaccess.o \
	mvar_aux.o mvar_dbg.o mvar_der.o mvar_det.o mvar_err.o \
	mvar_ftl.o mvar_gen.o mvar_pll.o \
	mvar_ref.o mvar_rev.o mvar_sub.o \
	mvar_sym.o mvarcmpt.o mvarcoer.o mvardist.o mvaredit.o \
	mvareval.o mvarmrph.o mvarrais.o mvartopo.o mvarzero.o \
	mv_crvtr.o mvbisect.o mvbspsym.o mvbzrpwr.o \
	mvbzrsym.o mvcones.o mvtangnt.o ray-trap.o skel2d.o

mvlowenv.o mvtrmbis.o mvvorcel.o mvvorcrv.o

all:	mvar.lib

mvar.lib: $(OBJS)
	rm -f mvar.lib
	oml mvar.lib a $(OBJS)

install: mvar.lib
	mv -f mvar.lib $(LIB_DIR)


# DO NOT DELETE THIS LINE -- make depend depends on it.

mvar_aux.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_aux.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_aux.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_aux.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_dbg.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_dbg.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_dbg.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_dbg.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_der.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_der.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_der.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_der.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_det.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_det.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_det.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_det.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_err.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_err.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_err.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_err.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_ftl.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_ftl.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_ftl.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_ftl.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_gen.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_gen.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_gen.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_gen.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_gen.o: ../include/geom_lib.h ../include/attribut.h
mvar_ref.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_ref.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_ref.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_ref.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_rev.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_rev.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_rev.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_rev.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_sub.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_sub.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_sub.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_sub.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvar_sym.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvar_sym.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvar_sym.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvar_sym.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvarcmpt.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvarcmpt.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvarcmpt.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvarcmpt.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvarcoer.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvarcoer.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvarcoer.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvarcoer.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvaredit.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvaredit.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvaredit.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvaredit.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvareval.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvareval.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvareval.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvareval.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvarmrph.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvarmrph.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvarmrph.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvarmrph.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvarmrph.o: ../include/geom_lib.h ../include/attribut.h
mvarrais.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvarrais.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvarrais.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvarrais.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvarzero.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvarzero.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvarzero.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvarzero.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvbisect.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvbisect.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvbisect.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvbisect.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvbspsym.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvbspsym.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvbspsym.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvbspsym.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvbzrsym.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvbzrsym.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvbzrsym.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvbzrsym.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
mvtangnt.o: mvar_loc.h ../include/irit_sm.h ../include/iritprsr.h
mvtangnt.o: ../include/cagd_lib.h ../include/miscattr.h ../include/misc_lib.h
mvtangnt.o: ../include/symb_lib.h ../include/trim_lib.h ../include/triv_lib.h
mvtangnt.o: ../include/trng_lib.h ../include/mdl_lib.h ../include/mvar_lib.h
